zoukankan      html  css  js  c++  java
  • hdu-3018 Ant Trip(欧拉路径)

    题目链接:

    Ant Trip

    Time Limit: 2000/1000 MS (Java/Others)   

     Memory Limit: 32768/32768 K (Java/Others)


    Problem Description
     
    Ant Country consist of N towns.There are M roads connecting the towns.

    Ant Tony,together with his friends,wants to go through every part of the country. 

    They intend to visit every road , and every road must be visited for exact one time.However,it may be a mission impossible for only one group of people.So they are trying to divide all the people into several groups,and each may start at different town.Now tony wants to know what is the least groups of ants that needs to form to achieve their goal.
     
    Input
     
    Input contains multiple cases.Test cases are separated by several blank lines. Each test case starts with two integer N(1<=N<=100000),M(0<=M<=200000),indicating that there are N towns and M roads in Ant Country.Followed by M lines,each line contains two integers a,b,(1<=a,b<=N) indicating that there is a road connecting town a and town b.No two roads will be the same,and there is no road connecting the same town.
     
    Output
     
    For each test case ,output the least groups that needs to form to achieve their goal.
     
    Sample Input
    3 3
    1 2
    2 3
    1 3
     
    4 2
    1 2
    3 4
     
    Sample Output
    1
    2
    Hint
    New ~~~ Notice: if there are no road connecting one town ,tony may forget about the town. In sample 1,tony and his friends just form one group,they can start at either town 1,2,or 3. In sample 2,tony and his friends must form two group.
     
    题意:
     
    就是给你无向图,问多少笔能把这些边都画完,所以孤立的点不用管;
     
    思路:
     
    NND ,一开始bfs写的有问题,我还以为有什么WA点,就在网上找题解,我擦,TMD全都是并查集,而且代码都一样,真想说一句去他大爷的;
    最后发现vis的位置不能乱放;
    bfs找到的一个连通块中,如果是一个欧拉回路ans+1,如果里面有奇度的点,那么肯定是成对出现的,因为一条边对应两个点的度,那么一次可以选一对奇度的点为起始点和终止点,那么这个连通块的答案就是这个连通块中奇度点的个数/2;
     
     
    AC代码
     
    #include <bits/stdc++.h>
    using namespace std;
    typedef long long ll;
    const int N=1e6+5;
    const ll mod=1e9+7;
    int n,m,vis[N],ind[N],u,v;
    vector<int>ve[N];
    queue<int>qu;
    int bfs(int num)
    {
        int cnt=0;
        qu.push(num);
        vis[num]=1;
        while(!qu.empty())
        {
            int fr=qu.front();
            qu.pop();
            if(ind[fr]%2==1)cnt++;
            int len=ve[fr].size();
            for(int i=0;i<len;i++)
            {
                int y=ve[fr][i];
                if(!vis[y])
                {
                    vis[y]=1;
                    qu.push(y);
                }
            }
        }
        return cnt;
    }
    int main()
    {
        while(scanf("%d%d",&n,&m)!=EOF)
        {
            for(int i=0;i<=n;i++)
            {
                ind[i]=vis[i]=0;
                ve[i].clear();
            }
            for(int i=0;i<m;i++)
            {
                scanf("%d%d",&u,&v);
                ve[u].push_back(v);
                ve[v].push_back(u);
                ind[u]++;
                ind[v]++;
            }
            for(int i=1;i<=n;i++)
            {
                if(ind[i]==0)vis[i]=1;
            }
            int ans=0;
            for(int i=1;i<=n;i++)
            {
                if(!vis[i])
                {
                    int s=bfs(i);
                    if(s==0)ans++;
                    else ans+=s/2;
                }
            }
            printf("%d
    ",ans);
    
        }
       return 0;
    }
  • 相关阅读:
    记第一场省选
    POJ 2083 Fractal 分形
    CodeForces 605A Sorting Railway Cars 思维
    FZU 1896 神奇的魔法数 dp
    FZU 1893 内存管理 模拟
    FZU 1894 志愿者选拔 单调队列
    FZU 1920 Left Mouse Button 简单搜索
    FZU 2086 餐厅点餐
    poj 2299 Ultra-QuickSort 逆序对模版题
    COMP9313 week4a MapReduce
  • 原文地址:https://www.cnblogs.com/zhangchengc919/p/5417979.html
Copyright © 2011-2022 走看看